## imx-vpu-cnm-9t 3.14.28-1.0.0-udoo

=== imx-lib.source/hdmi-cec/Makefile ===
CC ?=$(CROSS_COMPILE)gcc
AR ?=$(CROSS_COMPILE)ar
CFLAGS ?=-O2

# list of platforms which want this test case
INCLUDE_LIST:= IMX6Q

OBJ = mxc_hdmi-cec.o

LIBNAME = libcec
SONAMEVERSION=1

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))

ifeq ($(findstring IMX5, $(PLATFORM)), IMX5)
VERSION = imx5
else
VERSION = $(shell echo $(PLATFORM_STR) | awk '{print substr($$0, 1, 5)}' \
	| awk '{print  tolower($$0) }' )
endif

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp -P $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
	cp hdmi-cec.h $(DEST_DIR)/usr/include
else
all install :
endif

%.o: %.c
	$(CC) -D$(PLATFORM) -Wall -fPIC $(CFLAGS) -c $^ -o $@

$(LIBNAME).so.$(SONAMEVERSION): $(OBJ)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ $^ -o $@ $(LDFLAGS)

$(LIBNAME).so: $(LIBNAME).so.$(SONAMEVERSION)
	ln -s $< $@

$(LIBNAME).a: $(OBJ)
	$(AR) -rc $@  $^

.PHONY: clean
clean:
	rm -f $(LIBNAME).* $(OBJ)

=== imx-lib.source/pxp/Makefile ===
CC ?=$(CROSS_COMPILE)gcc
AR ?=$(CROSS_COMPILE)ar
CFLAGS ?=-O2

# list of platforms which want this test case
INCLUDE_LIST:=IMX50 IMX51 IMX5 IMX6Q IMX6S

OBJ = pxp_lib.o

LIBNAME = libpxp
SONAMEVERSION=0
LFLAGS += -lpthread

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp -P $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
	cp pxp_lib.h $(DEST_DIR)/usr/include
else
all install :
endif

%.o: %.c
	$(CC) -D$(PLATFORM) $(INCLUDE) -Wall -fPIC $(CFLAGS) -c $^ -o $@

$(LIBNAME).so.$(SONAMEVERSION): $(OBJ)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ $(LFLAGS) $^ -o $@ $(LDFLAGS)

$(LIBNAME).so: $(LIBNAME).so.$(SONAMEVERSION)
	ln -s $< $@

$(LIBNAME).a: $(OBJ)
	$(AR) -rc $@  $^

.PHONY: clean
clean:
	rm -f $(LIBNAME).* $(OBJ)

=== imx-lib.source/rng/Makefile ===
EXCLUDE_LIST:= IMX6Q IMX6S

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
AR = ar -crv
RM = rm -f
CC ?=$(CROSS_COMPILE)gcc
LD ?=$(CROSS_COMPILE)ld
CFLAGS ?=-g

INC := $(INCLUDE)

# Add compilation checks
override CFLAGS += -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement -fPIC

# In absence of kernel CONFIG flags, set API library to build on
# 'unknown' platform.
override CFLAGS += -DFSL_PLATFORM_OTHER -DFSL_HAVE_RNGC $(INC)

OBJS= fsl_shw_rand.o  fsl_shw_hash.o  fsl_shw_sym.o  fsl_shw_user.o         \
		fsl_shw_keystore.o fsl_shw_auth.o  fsl_shw_hmac.o  fsl_shw_wrap.o

LIBNAME=libfsl_shw
SONAMEVERSION=0

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp -P $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include

$(LIBNAME).a: $(OBJS)
	$(AR) $@ $^

$(LIBNAME).so.$(SONAMEVERSION): $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ $(LDFLAGS)

$(LIBNAME).so: $(LIBNAME).so.$(SONAMEVERSION)
	ln -s $< $@

.PHONY: clean
clean:
	@rm -f *.o $(LIBNAME).*

# The keystore file is located in the Sahara directory
fsl_shw_keystore.o: ../sahara2/fsl_shw_keystore.c
	$(CC) $(CFLAGS) -c ../sahara2/fsl_shw_keystore.c

else
OBJS =
all: ${OBJS}
install: ${OBJS}
endif

=== imx-lib.source/sahara2/Makefile ===
EXCLUDE_LIST:= IMX6Q IMX6S

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
AR = ar -crv
RM = rm -f
CC ?=$(CROSS_COMPILE)gcc
LD ?=$(CROSS_COMPILE)ld
CFLAGS ?=-g

INC := $(INCLUDE)

DIAGS=

ifeq ("$(PLATFORM)", "IMX27ADS")
TARGET_ARCH=-DCONFIG_ARCH_MX27
endif
ifeq ($(findstring IMX5, $(PLATFORM)), IMX5)
TARGET_ARCH=-DCONFIG_ARCH_MX5
endif

# Add compilation checks
override CFLAGS += -Wall -W -Wmissing-prototypes -Wstrict-prototypes -Wdeclaration-after-statement -fPIC

OBJS= fsl_shw_rand.o  fsl_shw_hash.o  fsl_shw_sym.o  fsl_shw_user.o         \
      fsl_shw_auth.o  fsl_shw_hmac.o  fsl_shw_wrap.o  fsl_shw_keystore.o um_adaptor.o  sf_util.o


#CFLAGS += -DSAHARA -DLINUX -I$(APIINCDIR)
override CFLAGS += -DSAHARA -DLINUX $(INC)
override CFLAGS += $(TARGET_ARCH)
# Uncomment to debug Library's creation of structures for driver
#override CFLAGS +=  -DDIAG_SECURITY_FUNC
# Uncomment to simulate memory allocation errors
#override CFLAGS += -DDIAG_MEM_ERRORS -DDIAG_MEM_CONST=5

LIBNAME=libsahara
SONAMEVERSION=0

ifeq ("$(TARGET_ARCH)", "")
all install:
else
all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp -P $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
endif


$(LIBNAME).a: $(OBJS)
	$(AR) $@ $^

$(LIBNAME).so.$(SONAMEVERSION): $(OBJS)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ -o $@ $^ $(LDFLAGS)

$(LIBNAME).so: $(LIBNAME).so.$(SONAMEVERSION)
	ln -s $< $@

.PHONY: clean
clean:
	@rm -f $(OBJS) $(LIBNAME).*

fsl_shw_rand.o: fsl_shw_rand.c $(API_INCL)

fsl_shw_hash.o: fsl_shw_hash.c $(API_INCL)

fsl_shw_sym.o: fsl_shw_sym.c $(API_INCL)

fsl_shw_user.o: fsl_shw_user.c $(API_INCL)

fsl_shw_hmac.o: fsl_shw_hmac.c $(API_INCL)

fsl_shw_auth.o: fsl_shw_auth.c $(API_INCL)

fsl_shw_wrap.o: fsl_shw_wrap.c

fsl_shw_keystore.o: fsl_shw_keystore.c
um_adaptor.o: um_adaptor.c

sf_util.o: sf_util.c
else
OBJS =
all: ${OBJS}
install: ${OBJS}
endif

=== imx-test.source/module_test/Makefile ===

ifneq ($(KERNELRELEASE),)
# kbuild part of makefile

# When adding modules, either add to the 'module_list' for all platfoms or add
# below to the 'module_list +=...' list for each platform that needs it.
module_list-$(CONFIG_MXC_SECURITY_SCC) += scc_test_driver.o
module_list-$(CONFIG_MXC_SECURITY_SCC2) += scc2_test_driver.o
module_list-$(CONFIG_MXC_SECURITY_RNG) += rng_test_driver.o
module_list-$(CONFIG_MXC_SAHARA) += sahara_test_driver.o
module_list-$(CONFIG_MXC_HMP4E) += memalloc.o
module_list-$(CONFIG_MXC_DRYICE) += dryice_test.o

# Build Sahara Kernel Test Module for RNG Kernel Mode Tests
ifeq ($(CONFIG_MXC_SECURITY_RNG),y)
module_list-y += sahara_test_driver.o
endif
ifeq ($(CONFIG_MXC_SDMA_API),y)
module_list-y += mxc_sdma_mem_test.o
endif
ifeq ($(CONFIG_FB_MXC_EINK_PANEL),y)
module_list-y += epdc_test_driver.o
endif
ifeq ($(CONFIG_FB_MXC_SIPIX_PANEL),y)
module_list-y += spdc_test_driver.o
endif

# sahara uses common files for both test application and test module
SAHARA_TEST_SOURCE=../test/mxc_sahara_test/

sahara_test_driver-objs := km_test.o $(SAHARA_TEST_SOURCE)run_tests.o \
                           $(SAHARA_TEST_SOURCE)results.o \
                           $(SAHARA_TEST_SOURCE)cap.o \
                           $(SAHARA_TEST_SOURCE)hash.o \
                           $(SAHARA_TEST_SOURCE)rand.o \
                           $(SAHARA_TEST_SOURCE)sym.o \
                           $(SAHARA_TEST_SOURCE)hmac1.o \
                           $(SAHARA_TEST_SOURCE)hmac2.o \
                           $(SAHARA_TEST_SOURCE)wrap.o \
                           $(SAHARA_TEST_SOURCE)apihelp.o \
                           $(SAHARA_TEST_SOURCE)gen_encrypt.o \
                           $(SAHARA_TEST_SOURCE)callback.o \
                           $(SAHARA_TEST_SOURCE)dryice.o \
                           $(SAHARA_TEST_SOURCE)smalloc.o \
                           $(SAHARA_TEST_SOURCE)user_wrap.o


obj-m += $(module_list-y) $(module_list-m)

EXTRA_CFLAGS := -DLINUX_KERNEL -DIMX_NEEDS_DEPRECATED_SYMBOLS

## NOTE: The following should be removed. They are directly requesting kernel
##       source.
EXTRA_CFLAGS += -I$(LINUXPATH)/drivers/mxc/security -I$(LINUXPATH)/drivers/mxc/security/rng/include -I$(LINUXPATH)/drivers/mxc/security/sahara2/include

all: obj-m
	$(MAKE) -C $(LINUXPATH) M=`pwd` KBUILD_OUTPUT=$(KBUILD_OUTPUT) ARCH=arm CROSS_COMPILE=$(CROSS_COMPILE)  obj-j

else

# Need to remove sahara objects because the test app uses same objects
all:
	$(MAKE) -C $(LINUXPATH) M=`pwd` KBUILD_OUTPUT=$(KBUILD_OUTPUT) ARCH=arm CROSS_COMPILE=$(CROSS_COMPILE)  modules

install:
	$(MAKE) -C $(LINUXPATH) INSTALL_MOD_DIR=test M=`pwd` KBUILD_OUTPUT=$(KBUILD_OUTPUT) ARCH=arm CROSS_COMPILE=$(CROSS_COMPILE)  modules_install

.PHONY: clean
clean :
	@rm -f *.o *.mod.c *.ko .*.cmd
	@rm -rf .tmp_versions
	@for X in $(shell /bin/ls -d */); do	\
		cd $$X;				\
		rm -f *.o *.mod.c *.ko .*.cmd;	\
		rm -rf .tmp_versions;		\
		cd ..;				\
	done
endif

=== imx-vpu.source/vpu/Makefile ===
CC ?=$(CROSS_COMPILE)gcc
AR ?=$(CROSS_COMPILE)ar
CFLAGS ?= -mthumb -O2 -march=armv7-a -mcpu=cortex-a9 -mtune=cortex-a9 -mfpu=neon -mvectorize-with-neon-quad -pipe -fomit-frame-pointer

# list of platforms which want this test case
INCLUDE_LIST:= IMX27ADS IMX51 IMX53 IMX6Q

OBJ = vpu_io.o vpu_util.o vpu_lib.o vpu_gdi.o vpu_debug.o

LIBNAME = libvpu
SONAMEVERSION=4

ifeq ($(PLATFORM), $(findstring $(PLATFORM), $(INCLUDE_LIST)))

ifeq ($(findstring IMX5, $(PLATFORM)), IMX5)
VERSION = imx5
else
VERSION = $(shell echo $(PLATFORM_STR) | awk '{print substr($$0, 1, 5)}' \
	| awk '{print  tolower($$0) }' )
endif

all: $(LIBNAME).so $(LIBNAME).a

install: install_headers
	@mkdir -p $(DEST_DIR)/usr/lib
	cp -P $(LIBNAME).* $(DEST_DIR)/usr/lib

install_headers:
	@mkdir -p $(DEST_DIR)/usr/include
	cp vpu_lib.h $(DEST_DIR)/usr/include
	cp vpu_io.h $(DEST_DIR)/usr/include
else
all install :
endif

%.o: %.c
	$(CC) -D$(PLATFORM) -Wall -fPIC $(CFLAGS) -c $^ -o $@

$(LIBNAME).so.$(SONAMEVERSION): $(OBJ)
	$(CC) -shared -nostartfiles -Wl,-soname,$@ $^ -o $@ $(LDFLAGS) -lpthread

$(LIBNAME).so: $(LIBNAME).so.$(SONAMEVERSION)
	ln -s $< $@

$(LIBNAME).a: $(OBJ)
	$(AR) -rc $@  $^

.PHONY: clean
clean:
	rm -f $(LIBNAME).* $(OBJ)

=== imx-test.source/test/imx_adc/Makefile ===
#
# Makefile for IMX ADC driver test app.
#
# list of platforms which did not want this test case
INCLUDE_LIST:= IMX25_3STACK

ifeq ($(PLATFORM),$(findstring $(PLATFORM),$(INCLUDE_LIST)))
OBJS = \
	$(OBJDIR)/imx_adc_test.out
else
OBJS =
endif

CFLAGS += -I$(LINUXPATH)/include/

all : $(OBJS)

.PHONY: clean
clean :
	rm -f $(OBJS)

#
# include the Rules
#
include ../make.rules

=== imx-test.source/test/max8660_pmic_test/Makefile ===
# list of platforms which did not want this test case
EXCLUDE_LIST:="IMX51 IMX37_3STACK IMX31_3STACK IMX31ADS IMX27_3STACK IMX27ADS IMX25_3STACK IMX6Q IMX6SL IMX6SX"


LTP_DIR = $(TOPDIR)/test/mxc_pmic_test/
LOADLIBES+= -L$(LTP_DIR)lib -lltp

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
OBJS = autorun-mcu_pmic.sh libltp.a
else
OBJS =
endif

CFLAGS+= -Wall -I$(LTP_DIR)/include
CFLAGS+= $(INC) -I$(LINUXPATH)/include/ -D__CVS_TEST

CFLAGS+= -DCONFIG_MXC_PMIC_MC9SDZ60

export CFLAGS LTP_DIR LOADLIBES

SUBDIRS =       protocol_tests \
		pmic_testapp_rtc

all: $(OBJS)
ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
	@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i ; done
endif

libltp.a:
	@$(MAKE) -C $(LTP_DIR)lib/ $@
	mkdir -p $(OBJDIR)
	@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i ; done

install:
	@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i install ; done

.PHONY: clean
clean:
	@$(MAKE) -C lib clean
	@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean ; done
#
# include the Rules
#
include ../make.rules

=== imx-test.source/test/memtool/Makefile ===
# list of platforms which did not want this test case
EXCLUDE_LIST:=

LINK ?=$(CROSS_COMPILE)gcc
STRIP ?=$(CROSS_COMPILE)strip

OBJ = memtool.o \
      mx6dl_modules.o \
      mx6q_modules.o \
      mx6sl_modules.o \
      mx6sx_modules.o

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
TARGET = $(OBJDIR)/memtool
else
TARGET =
endif

CFLAGS+= -Os

all : $(TARGET)

$(TARGET):$(OBJ)
	$(CC) -o $(TARGET) $(OBJ) -Os
	$(STRIP) $(TARGET)

.PHONY: clean
clean :
	rm -f $(OBJ)

#
# include the Rules
#
include ../make.rules

=== imx-test.source/test/mmdc/Makefile ===
# list of platforms which did not want this test case
EXCLUDE_LIST:=

LINK ?=$(CROSS_COMPILE)gcc
STRIP ?=$(CROSS_COMPILE)strip

OBJ = mmdc.o

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
TARGET = $(OBJDIR)/mmdc2
else
TARGET =
endif

CFLAGS+= -Os

LDFLAGS+= -lstdc++

all : $(TARGET)

$(TARGET):$(OBJ)
	$(CC) -o $(TARGET) $(OBJ) $(LDFLAGS) -Os
	$(STRIP) $(TARGET)

.PHONY: clean
clean :
	rm -f $(OBJ)

#
# include the Rules
#
include ../make.rules

=== imx-test.source/test/mxc_als_test/Makefile ===
# list of platforms which did not want this test case
EXCLUDE_LIST:=

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
OBJS = $(OBJDIR)/mxc_isl29023.out
else
OBJS =
endif

all : $(OBJS)

.PHONY: clean
clean :
	rm -f $(OBJS)

#
# include the Rules
#
include ../make.rules

=== imx-test.source/test/mxc_asrc_test/Makefile ===
#
# Makefile for OSS sound driver test app.
#
# list of platforms which did not want this test case
EXCLUDE_LIST:= IMX21ADS IMX27ADS IMX31ADS IMX32ADS IMX37_3STACK IMX25_3STACK

CFLAGS += -lpthread

ifeq (,$(findstring $(PLATFORM), $(EXCLUDE_LIST)))
OBJS = \
	$(OBJDIR)/mxc_asrc_test.out \
	$(OBJDIR)/autorun-asrc.sh
else
OBJS =
endif

all : $(OBJS)
	cp audio8k16S.wav $(OBJDIR)

.PHONY: clean
clean :
	rm -f $(OBJS)

#
# include the Rules
#
include ../make.rules

=== debian/changelog ===
imx-vpu-cnm-9t (3.14.28-1.0.0-udoo) trusty; urgency=medium

  * Updated fsl-alsa, libfslvpuwrap, libfslcodec, libfslparser from upstream.

 -- Francesco Montefoschi <francesco.monte@gmail.com>  Wed, 11 Nov 2015 09:11:43 +0000

imx-vpu-cnm-9t (3.14.28-1.0.0-1boundary4) trusty; urgency=medium

  * Initial Boundary package
  * Based on meta-fsl-arm imx-3.14.28-1.0.1_patch release

 -- Laci Tele <laci@boundarydevices.com>  Fri, 17 Jul 2015 15:00:45 -0700

=== debian/control ===
Source: imx-vpu-cnm-9t
Section: restricted/libs
Priority: optional
Maintainer: Laci Tele <laci@boundarydevices.com>
Build-Depends: debhelper (>= 8), execstack, asciidoc, findutils (>= 4.2.28), autotools-dev, autoconf, automake, libtool
Standards-Version: 3.9.3
Homepage: http://www.boundarydevices.com/
#Vcs-Git: https://github.com/boundarydevices


Package: fsl-alsa-plugins-9t
Section: libs
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Freescale alsa-lib plugins


Package: imx-lib-9t
Section: libs
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Platform specific libraries for imx platform


Package: imx-vpu-9t
Section: libs
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Freescale VPU library


Package: imx-test-9t
Section: base
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Unit tests for the imx-bsp


Package: firmware-imx-9t
Section: restricted/base
Architecture: armel armhf
Description: Freescale IMX firmware such as for the VPU


Package: gst-fsl-plugins-9t
Section: multimedia
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Freescale gstreamer plugins


Package: libfslcodec-9t
Section: restricted/multimedia
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Freescale Multimedia codec libs


Package: libfslparser-9t
Section: restricted/multimedia
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Freescale Multimedia parser libs


Package: libfslvpuwrap-9t
Section: restricted/multimedia
Architecture: armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Freescale Multimedia VPU wrapper


Package: imx-vpu-cnm-9t
Section: metapackages
Architecture: armel armhf
Depends: fsl-alsa-plugins-9t (= ${binary:Version}), 
         imx-lib-9t (= ${binary:Version}),
         imx-vpu-9t (= ${binary:Version}),
         firmware-imx-9t (= ${binary:Version}),
         gst-fsl-plugins-9t (= ${binary:Version}),
         libfslcodec-9t (= ${binary:Version}),
         libfslparser-9t (= ${binary:Version}),
         libfslvpuwrap-9t (= ${binary:Version}),
         imx-udev-fsl-rules
Description: VPU acceleration for imx6

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*- -*- indent-tabs-mode: t; tab-width: 3 -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#usage: $(call message,<text>,<tabs>,<color>,<inverse>)
#message colors
COLOR_BLACK=30
COLOR_RED=31
COLOR_GREEN=32
COLOR_YELLOW=33
COLOR_BLUE=34
COLOR_MAGENTA=35
COLOR_CYAN=36
COLOR_WHITE=97
COLOR_DEFAULT=39
MSG_INVERSE=1
MSG_NONINVERSE=0

define message
	( if [ -z $(NOCOLOR) ] ; then echo -ne "\e[$(3)m" ; fi ; \
	if [ "$(4)" = "$(MSG_INVERSE)" ] ; then if [ -z $(NOCOLOR) ] ; then echo -ne "\e[7m" ; fi ; echo -n ">>>" ; fi ; \
	if [ "$(2)" -gt 0 ] && [ "$(2)" -lt 10 ] ; then for a in `seq "$(2)"` ; do echo -n "   " ; done ; fi ; \
	echo -n " $(1) " ; \
	if [ "$(4)" = "$(MSG_INVERSE)" ] ; then echo -n "<<<" ; if [ -z $(NOCOLOR) ] ; then echo -ne "\e[27m" ; fi ; fi ; \
	echo ; \
	if [ -z $(NOCOLOR) ] ; then echo -ne "\e[39m" ; fi ; \
	)
endef

##########################

DEB_HOST_GNU_CPU  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH     ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
SHELL = /bin/bash

ifeq ($(DEB_HOST_GNU_TYPE),arm-linux-gnueabihf)
BUILD_HARD_VFP = 1
else ifeq ($(DEB_HOST_GNU_TYPE),arm-linux-gnueabi)
BUILD_HARD_VFP =
else
#$(error DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE))
endif

PF          := -9t
FSL_APLUG   := fsl-alsa-plugins
IMX_LIB     := imx-lib
IMX_VPU     := imx-vpu
LFSL_CODC   := libfslcodec
LFSL_PARS   := libfslparser
LFSL_VPUW   := libfslvpuwrap
GFSL_PLUG   := gst-fsl-plugins
IMX_TEST    := imx-test
FIRM_IMX    := firmware-imx

TOP_DIR            := ${PWD}
export STAGING_DIR := ${PWD}/staging


CONFIG_OPTS = --prefix=/usr --build $(DEB_BUILD_GNU_TYPE)

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
IMX_LIB_BUILD_OPTS	+= CC=$(DEB_HOST_GNU_TYPE)-gcc AR=$(DEB_HOST_GNU_TYPE)-ar
IMX_VPU_BUILD_OPTS	+= CC=$(DEB_HOST_GNU_TYPE)-gcc AR=$(DEB_HOST_GNU_TYPE)-ar
IMX_TEST_BUILD_OPTS	+= CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- V=1
CONFIG_OPTS				+= --host $(DEB_HOST_GNU_TYPE)
endif

##

FSL_APLUG_CONFIG_OPTS = $(CONFIG_OPTS) \
	CFLAGS="$(CFLAGS) -I${STAGING_KERNEL_DIR}/include/uapi -I${STAGING_KERNEL_DIR}/include"

LFSL_CODC_CONFIG_OPTS = $(CONFIG_OPTS) \
	--enable-vpu --enable-fhw

LFSL_PARS_CONFIG_OPTS = $(CONFIG_OPTS) \
	--enable-fhw

LFSL_VPUW_CONFIG_OPTS = $(CONFIG_OPTS) \
	CFLAGS="$(CFLAGS) -I$(STAGING_DIR)/usr/include" \
	LDFLAGS="-L$(STAGING_DIR)/usr/lib"

GFSL_PLUG_CONFIG_OPTS = $(CONFIG_OPTS) \
	PLATFORM=MX6 \
	CFLAGS="$(CFLAGS) -I${STAGING_KERNEL_DIR}/include/uapi -I${STAGING_KERNEL_DIR}/include $(CFLAGS) -I$(STAGING_DIR)/usr/include" \
	PKG_CONFIG_PATH="/usr/lib/$(DEB_HOST_GNU_TYPE)/pkgconfig:$(STAGING_DIR)/usr/lib/pkgconfig:/usr/lib/pkgconfig"

##

IMX_LIB_BUILD_OPTS += \
	INCLUDE="-I${STAGING_KERNEL_DIR}/include/uapi -I${STAGING_KERNEL_DIR}/include \
				-I${STAGING_KERNEL_DIR}/drivers/mxc/security/rng/include \
				-I${STAGING_KERNEL_DIR}/drivers/mxc/security/sahara2/include" \
	PLATFORM="IMX6Q"

IMX_VPU_BUILD_OPTS += \
	INCLUDE_DIR="-I${STAGING_KERNEL_DIR}/include/uapi -I${STAGING_KERNEL_DIR}/include" \
	PLATFORM="IMX6Q"


IMX_TEST_BUILD_OPTS += \
	INC="-I${STAGING_DIR}/usr/include \
		  -I${TOP_DIR}/$(IMX_TEST).source/include \
		  -I${STAGING_KERNEL_DIR}/include/uapi \
		  -I${STAGING_KERNEL_DIR}/include \
		  -I${STAGING_KERNEL_DIR}/arch/arm/include \
		  -I${STAGING_KERNEL_DIR}/drivers/mxc/security/rng/include \
		  -I${STAGING_KERNEL_DIR}/drivers/mxc/security/sahara2/include" \
	PLATFORM="IMX6Q" \
	LINUXPATH=${STAGING_KERNEL_DIR} KBUILD_OUTPUT=${STAGING_KERNEL_DIR} \
	STAGING_LIBS="-L${STAGING_DIR}/usr/lib"

##

%:
	dh $@ --with python2

#override_dh_auto_configure:
#	dh_testdir
#	dh_auto_configure --list
#	exit 2

build_staging:
	mkdir -p $(STAGING_DIR)
	#
	# imx-lib
	@$(call message,"building imx-lib for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	dh_auto_build		-v --buildsystem=makefile -pimx-lib$(PF)												-- $(IMX_LIB_BUILD_OPTS) -C $(IMX_LIB).source all
	dh_auto_install	-v --buildsystem=makefile -pimx-lib$(PF)			--destdir=$(STAGING_DIR)	-- -C $(IMX_LIB).source PLATFORM=IMX6Q DEST_DIR=\$${DESTDIR}
	#
	# imx-vpu
	@$(call message,"building imx-vpu for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	dh_auto_build		-v --buildsystem=makefile -pimx-vpu$(PF)												-- $(IMX_VPU_BUILD_OPTS) -C $(IMX_VPU).source all
	dh_auto_install	-v --buildsystem=makefile -pimx-vpu$(PF)			--destdir=$(STAGING_DIR)	-- -C $(IMX_VPU).source PLATFORM=IMX6Q DEST_DIR=\$${DESTDIR}
	#
	# libfslcodec
	@$(call message,"configuring libfslcodec for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	(cd $(LFSL_CODC).source && ./autogen.sh $(LFSL_CODC_CONFIG_OPTS))
	@$(call message,"building libfslcodec for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	dh_auto_build		-v --buildsystem=makefile -plibfslcodec$(PF)										-- -C $(LFSL_CODC).source all
	dh_auto_install	-v --buildsystem=makefile -plibfslcodec$(PF)	--destdir=$(STAGING_DIR)	-- -C $(LFSL_CODC).source
	#
	# libfslparser
	@$(call message,"configuring libfslparser for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	(cd $(LFSL_PARS).source && ./autogen.sh $(LFSL_PARS_CONFIG_OPTS))
	@$(call message,"building libfslparser for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	dh_auto_build		-v --buildsystem=makefile -plibfslparser$(PF)										-- -C $(LFSL_PARS).source all
	dh_auto_install	-v --buildsystem=makefile -plibfslparser$(PF)	--destdir=$(STAGING_DIR)	-- -C $(LFSL_PARS).source
	#
	# libfslvpuwrap
	@$(call message,"configuring libfslvpuwrap for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	(cd $(LFSL_VPUW).source && ./autogen.sh $(LFSL_VPUW_CONFIG_OPTS))
	@$(call message,"building libfslvpuwrap for staging...",0,$(COLOR_MAGENTA),$(MSG_INVERSE))
	dh_auto_build		-v --buildsystem=makefile -plibfslvpuwrap$(PF)										-- -C $(LFSL_VPUW).source all
	dh_auto_install	-v --buildsystem=makefile -plibfslvpuwrap$(PF)	--destdir=$(STAGING_DIR)	-- -C $(LFSL_VPUW).source
	#
	# adjusting pkconfig files
	(pcfiles=`find $(STAGING_DIR)/usr/lib/pkgconfig -type f -name '*.pc'` ; \
		for file in $${pcfiles} ; do \
			sudo sed -e s,"prefix=/usr","prefix=$(STAGING_DIR)/usr",g -i $${file} ; \
		done \
	)


override_dh_auto_build: build_staging
	#
	# fsl-alsa-plugins
	@$(call message,"configuring fsl-alsa-plugins for release...",0,$(COLOR_CYAN),$(MSG_INVERSE))
	(cd $(FSL_APLUG).source && aclocal && autoconf && automake --add-missing && ./configure $(FSL_APLUG_CONFIG_OPTS))
	dh_auto_build -v --buildsystem=makefile -pfsl-alsa-plugins$(PF)	-- -C $(FSL_APLUG).source all
	#
	# libfslcodec
	@$(call message,"configuring libfslcodec for release...",0,$(COLOR_CYAN),$(MSG_INVERSE))
	(cd $(LFSL_CODC).source && ./autogen.sh $(LFSL_CODC_CONFIG_OPTS))
	dh_auto_build -v --buildsystem=makefile -plibfslcodec$(PF)			-- -C $(LFSL_CODC).source all
	#
	# libfslparser
	@$(call message,"configuring libfslparser for release...",0,$(COLOR_CYAN),$(MSG_INVERSE))
	(cd $(LFSL_PARS).source && ./autogen.sh $(LFSL_PARS_CONFIG_OPTS))
	dh_auto_build -v --buildsystem=makefile -plibfslparser$(PF)			-- -C $(LFSL_PARS).source all
	#
	# libfslvpuwrap
	@$(call message,"configuring libfslvpuwrap for release...",0,$(COLOR_CYAN),$(MSG_INVERSE))
	(cd $(LFSL_VPUW).source && ./autogen.sh $(LFSL_VPUW_CONFIG_OPTS))
	dh_auto_build -v --buildsystem=makefile -plibfslvpuwrap$(PF)		-- -C $(LFSL_VPUW).source all
	#
	# gst-fsl-plugins
	@$(call message,"configuring gst-fsl-plugins for release...",0,$(COLOR_CYAN),$(MSG_INVERSE))
	(cd $(GFSL_PLUG).source && ./autogen.sh $(GFSL_PLUG_CONFIG_OPTS))
	dh_auto_build -v --buildsystem=makefile -pgst-fsl-plugins$(PF)		-- -C $(GFSL_PLUG).source all
	# imx-test
	@$(call message,"building imx-test for release...",0,$(COLOR_CYAN),$(MSG_INVERSE))
	dh_auto_build -v --buildsystem=makefile -pimx-test$(PF)				-- $(IMX_TEST_BUILD_OPTS) -C $(IMX_TEST).source test
	# firmware-imx


override_dh_auto_install:
